config/routes.rb
Rails.application.routes.draw do

  # Serve websocket cable requests in-process
  # mount ActionCable.server => '/cable'

  root 'store#home', as: 'store_home'

  get 'info/index'
  get 'store/index'

  get "all_users_path" => "users#index"

  get 'admin' => 'admin#index'
  get "/products/show/" => "products#one"
  get "/store/filter" => "store#filterProducts"
  get "/orders/o" => "orders#one"

  controller :sessions do
    get 'login' => :new
    post 'login' => :create
    delete 'logout' => :destroy
    get 'logout' => :destroy
  end

  resources :users
  resources :orders
  resources :line_items
  resources :carts

  resources :products do
    get :who_bought, on: :member
  end

  resources :line_items do
    put 'decrease', on: :member
    put 'increase', on: :member
  end


  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/cart.rb
class Cart < ApplicationRecord
  has_many :line_items, dependent: :destroy

  def decrease(line_item_id)
    current_item = line_items.find(line_item_id)
    if current_item.quantity > 1
      current_item.quantity -= 1
    else
      current_item.destroy
    end
    current_item
  end

  def increase(line_item_id)
    current_item = line_items.find(line_item_id)
    current_item.quantity += 1
    current_item
  end

  def add_product(product)
    current_item = line_items.find_by(product_id: product.id)
    if current_item
        current_item.quantity += 1
    else
      current_item = line_items.build(product_id: product.id)
    end
    current_item
  end

  def total_price
    line_items.to_a.sum { |item| item.total_price }
  end
end

app/models/line_item.rb
class LineItem < ApplicationRecord
  belongs_to :order, optional: true
  belongs_to :product, optional: true
  belongs_to :cart

  def total_price
    product.price * quantity
  end

end

app/models/order.rb
class Order < ApplicationRecord
  has_many :line_items, dependent: :destroy

  enum pay_type: {
    "Check" => 0,
    "Credit card" => 1,
    "Purchase order" => 2
  }

  validates :name, :address, :email, presence: true
  validates :pay_type, inclusion: pay_types.keys

  def add_line_items_from_cart(cart)
    cart.line_items.each do |item|
      item.cart_id = nil
      line_items << item
    end
  end

end

app/models/product.rb
class Product < ApplicationRecord
  has_many :line_items
  has_many :orders, through: :line_items

  enum prod_types: {
    "Books" => 0,
    "Sunglasses" => 1,
    "Other" => 2
  }

  before_destroy :ensure_not_referenced_by_any_line_item
  before_update :changeType
  validates :title, :description, presence: true
  validates :price, numericality: {greater_than_or_equal_to: 0.01}
  validates :title, uniqueness: true
  validates :image_url, allow_blank: true, format: {
      with: %r{\.(gif|jpg|png)\Z}i,
      message: 'must be a URL for GIF, JPG or PNG image.'
  }

  private
    # ensure that there are no line items referencing this product
    def ensure_not_referenced_by_any_line_item
      unless line_items.empty?
        errors.add(:base, 'Line Items present')
        throw :abort
    end
  end

  def changeType
    self.prod_type = "Books"
  end
end

app/models/user.rb
class User < ApplicationRecord
  after_destroy :ensure_an_admin_remains

  class Error < StandardError
  end

  validates :name, presence: true, uniqueness: true
  has_secure_password

  private
    def ensure_an_admin_remains
      if User.count.zero?
        raise Error.new "Can't delete last user"
      end
    end
end

app/controllers/admin_controller.rb
class AdminController < ApplicationController
  skip_before_action :authorize, only: :index
  def index
    render layout: "admin_application"
    #@total_orders = Order.count
    #@username = User.find_by(id: session[:user_id]).name
  end
end

app/controllers/carts_controller.rb
class CartsController < ApplicationController
  skip_before_action :authorize, only: [:create, :update, :destroy]
  before_action :set_cart, only: [:show, :edit, :update, :destroy]
  rescue_from ActiveRecord::RecordNotFound, with: :invalid_cart

  # GET /carts
  # GET /carts.json
  def index
    @carts = Cart.all
  end

  # GET /carts/1
  # GET /carts/1.json
  def show
  end

  # GET /carts/new
  def new
    @cart = Cart.new
  end

  # GET /carts/1/edit
  def edit
  end

  # POST /carts
  # POST /carts.json
  def create
    @cart = Cart.new(cart_params)

    respond_to do |format|
      if @cart.save
        format.html { redirect_to @cart, notice: 'Cart was successfully created.' }
        format.json { render :show, status: :created, location: @cart }
      else
        format.html { render :new }
        format.json { render json: @cart.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /carts/1
  # PATCH/PUT /carts/1.json
  def update
    respond_to do |format|
      if @cart.update(cart_params)
        format.html { redirect_to @cart, notice: 'Cart was successfully updated.' }
        format.json { render :show, status: :ok, location: @cart }
      else
        format.html { render :edit }
        format.json { render json: @cart.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /carts/1
  # DELETE /carts/1.json
  def destroy
    @cart.destroy if @cart.id == session[:cart_id]
    session[:cart_id] = nil
    respond_to do |format|
      format.html { redirect_to store_home_url, notice: 'Cart successfully deleted.'}
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_cart
      @cart = Cart.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def cart_params
      params.fetch(:cart, {})
    end

    def invalid_cart
      logger.error "Attempt to access invalid cart #{params[:id]}"
      redirect_to store_index_url, notice: 'Invalid cart'
    end
end

app/controllers/info_controller.rb
class InfoController < ApplicationController

  skip_before_action :authorize
  
  def index
  end
end

app/controllers/store_controller.rb
class StoreController < ApplicationController
  skip_before_action :authorize

  include CurrentCart
  before_action :set_cart
  def index
    #@header = "Store"
    @products = Product.order(:title)
  end

  def home
    @products = Product.order(:title)
  end

  def filterProducts
    @header = params[:sort]
    if @header == "Other"
      @products = Product.all.select { |product| product.prod_type == "Sunglasses" || product.prod_type == "Other"}
    else
      @products = Product.all.select { |product| product.prod_type == @header }
    end
  end

end

app/helpers/admin_helper.rb
module AdminHelper
end

app/helpers/application_helper.rb
module ApplicationHelper
  def hidden_div_if(condition, attributes = {}, &block)
    if condition
      attributes["style"] = "display: none"
    end
    content_tag("div", attributes, &block)
  end
end

app/helpers/carts_helper.rb
module CartsHelper
end

app/helpers/info_helper.rb
module InfoHelper
end

app/helpers/line_items_helper.rb
module LineItemsHelper
end

app/helpers/orders_helper.rb
module OrdersHelper
end

app/helpers/products_helper.rb
module ProductsHelper
end

app/helpers/sessions_helper.rb
module SessionsHelper
end

app/helpers/store_helper.rb
module StoreHelper
end

app/helpers/users_helper.rb
module UsersHelper
end

app/views/admin/index.html.erb
<p id="notice"><%= notice %></p>

<h2 class="admin_header" id="Admin">Welcome to Admin Site</h2>

<p class="admin_header">
  <% user = User.find_by(id: session[:user_id]) %>
  <% if user %>
  <p id="<%= user.name %>">
    Logged in user: <%= user.name %>
    <%= link_to 'Edit', edit_user_path(user) %>
    <%= link_to 'Delete', user, method: :delete %>
  <% end %>
  </p>
</p>

<!-- We have <%= pluralize(@total_orders, "order") %>. -->

app/views/layouts/admin_application.html.erb
<!DOCTYPE html>
<html>
<head>

  <title>ST Online Store</title>
    <%= stylesheet_link_tag "application", media: "all", "data-turbolinks-track" => 'reload' %>
    <%= javascript_include_tag "application", "data-turbolinks-track" => 'reload' %>
    <%= csrf_meta_tags %>

</head>

<body class="<%= controller.controller_name %>">

  <div id="banner">
    ST ONLINE STORE
    <!-- <%= image_tag 'logo.svg', alt: 'The Pragmatic Bookshelf' %> -->

    <!-- <span class="title"><%= @page_title %></span> -->
  </div>

  <div class="columns">
    <div id="menu">
      <ul>
        <li><%= link_to 'Admin', admin_path %></li>
        <% if session[:user_id] %>
            <!-- <li class="admin_menu"><%= link_to 'Orders', orders_path %></li> -->
            <li class="admin_menu"><%= link_to 'Products', products_path %></li>
            <!-- <li class="admin_menu"><%= link_to 'Users', users_path %></li> -->
            <li><%= link_to 'Logout', logout_path, method: :delete %></li>
        <% else %>
            <li><%= link_to 'Login', login_path %></li>
            <li><%= link_to 'Register', new_user_path %></li>
        <% end %>

      </ul>

    </div>
  </div>

  <div class="columns" id="white_bar">
  </div>

  <div class="columns" id="column2">

    <div id="side">
      <div id="cart">
        <% if @cart and not session[:user_id]%>
          <%= hidden_div_if(@cart.line_items.empty?, id: 'cart') do %>
            <%= render @cart %>
          <% end %>
        <% end %>
      </div>
    </div>

    <div id="main">
      <%= yield %>
    </div>
  </div>

</body>

<div class="footer">
  <p><strong>Powered by UT</strong></p>
</div>


</html>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>

  <title>ST Online Store</title>
    <%= stylesheet_link_tag "application", media: "all", "data-turbolinks-track" => 'reload' %>
    <%= javascript_include_tag "application", "data-turbolinks-track" => 'reload' %>
    <%= csrf_meta_tags %>

</head>

<body class="<%= controller.controller_name %>">

  <div id="banner">
    ST ONLINE STORE
    <!-- <%= image_tag 'logo.svg', alt: 'The Pragmatic Bookshelf' %> -->

    <!-- <span class="title"><%= @page_title %></span> -->
  </div>

  <div class="columns">
    <div id="menu">
      <ul>

        <li><a href="/">Home</a></li>
        <li><%= link_to "Sunglasses", controller: "store", action: "filterProducts", sort: "Sunglasses" %></li>
        <li><%= link_to "Books", controller: "store", action: "filterProducts", sort: "Books" %></li>
        <li><%= link_to "Other", controller: "store", action: "filterProducts", sort: "Other" %></li>

        <!-- <% if session[:user_id] %>
            <li class="admin_menu"><%= link_to 'Orders', orders_path %></li>
            <li class="admin_menu"><%= link_to 'Products', products_path %></li>
            <li class="admin_menu"><%= link_to 'Users', users_path %></li>
        <% else %>
            <li><a href="/">Home</a></li>
            <li><%= link_to "Sunglasses", controller: "store", action: "filterProducts", header: "Sunglasses" %></li>
            <li><%= link_to "Books", controller: "store", action: "filterProducts", header: "Books" %></li>
            <li><%= link_to "Varia", controller: "store", action: "filterProducts", header: "Varia" %></li>
        <% end %>

        <li><a href="http://www..../news">Feedback</a></li>
        <li><%= link_to 'Info', info_index_path %></li>

        <% if session[:user_id] %>
            <li><%= link_to 'Logout', logout_path, method: :delete %></li>
        <% else %>
            <li><%= link_to 'Login', login_path, method: :create %></li>
            <li><%= link_to 'Register', new_user_path %></li>
        <% end %> -->

      </ul>

    </div>
  </div>

  <div class="columns" id="white_bar">
  </div>

  <div class="columns" id="column2">

    <div id="side">
      <div id="cart">
        <!-- <% if @cart and not session[:user_id]%>
          <%= hidden_div_if(@cart.line_items.empty?, id: 'cart') do %>
            <%= render @cart %>
          <% end %>
        <% end %> -->
        <% if @cart %>
          <%= render @cart %>
        <% end %>
      </div>
    </div>

    <div id="main">
      <%= yield %>
    </div>
  </div>

</body>

<div class="footer">
  <p><strong>Powered by UT</strong></p>
</div>


</html>